//+------------------------------------------------------------------+
//|                                                   Devolatile.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, TheXpert"
#property link      "theforexpert@gmail.com"

extern int     ATRPeriod      = 14;
extern int     SmoothPeriod   = 20;
extern double  coef           = 1000;


#property indicator_separate_window

#property indicator_buffers 4

#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Red


double Hi[];
double Lo[];
double Op[];
double Cl[];

int init()
{
   SetIndexBuffer(0, Hi);
   SetIndexBuffer(1, Lo);
   SetIndexBuffer(2, Op);
   SetIndexBuffer(3, Cl);

   return(0);
}

int start()
{
   int toCount = MathMin(Bars - 1, Bars - IndicatorCounted());
   
   for (int i = toCount - 1; i >= 0; i--)
   {
      double volatility = coef*iCustom(Symbol(), 0, "DSATR", ATRPeriod, SmoothPeriod, 0, i);
      Print("volatility = ", DoubleToStr(volatility, 8));
      
      if (volatility == 0)
      {
         Hi[i] = EMPTY_VALUE;
         Lo[i] = EMPTY_VALUE;
         Op[i] = EMPTY_VALUE;
         Cl[i] = EMPTY_VALUE;
      }
      else
      {
         if (Cl[i + 1] == EMPTY_VALUE)
         {
            Op[i] = 1;
            Hi[i] = 1 + (High[i] - Open[i])/volatility;
            Lo[i] = 1 + (Low[i] - Open[i])/volatility;
            Cl[i] = 1 + (Close[i] - Open[i])/volatility;
         }
         else
         {
            Op[i] = Cl[i + 1] + (Open[i] - Close[i + 1])/volatility;
            Hi[i] = Op[i] + (High[i] - Open[i])/volatility;
            Lo[i] = Op[i] + (Low[i] - Open[i])/volatility;
            Cl[i] = Op[i] + (Close[i] - Open[i])/volatility;
         }
      }
   }
}

